<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlarmScreenNg: Admin Settings</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlarmScreenNg
   &#160;<span id="projectnumber">0.9.2</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li class="current"><a href="pages.html"><span>Related&#160;Pages</span></a></li>
    </ul>
  </div>
<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="page_Config.html">Customization</a></li>  </ul>
</div>
</div><!-- top -->
<div class="PageDoc"><div class="header">
  <div class="headertitle">
<div class="title">Admin Settings </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><p>The AS components are installed without any access control presets - any user is allowed to perform all actions available from the AS interface, including changing its configuration. Such mode of operation may be convenient for test and development setups, but is rarely appropriate for production systems.</p>
<p>It is expected that for production projects, different access rights will be assigned to different users. This section describes configuration actions that in most cases will be performed by administrators and system experts. Therefore, they are called 'admin settings' throughout this document.</p>
<p>Admin settings are available through the popup menu of the 'Settings...' button in the toolbar of the AS footer:</p>
<p><a class="anchor" id="anchor_AdminMenu"></a></p><div class="image">
<img src="configAdminMenu.png" alt=""/>
<div class="caption">
The Admin Settings menu</div></div>
 <h1><a class="anchor" id="sec_AccessControl"></a>
Access Control</h1>
<p>Access Control is probably one of the very first things to be configured after the AS is installed. Every action that can be performed from the AS EWO, or from other panels that come with it, is identified by a unique action name. See <a class="el" href="page_RefActions.html">Action names</a> for more information.</p>
<p>The following panel is used to edit the access rights required to execute different actions:</p>
<div class="image">
<img src="accessControlEditor.png" alt=""/>
<div class="caption">
Editing access control for AS actions</div></div>
 <p>The table displays all action names and a 'short summary' of restrictions for each action.</p>
<p>Note that action names are used not only for access control, but also to identify the requested action in CTRL code, see <a class="el" href="page_RefActions.html">Action names</a>. For this reason, there are two action names in the table which are <b>not</b> subject to access control by their nature; there are no buttons for these actions in the <b>Access</b> column; instead the column just displays green cells.</p>
<p>For all other actions, the <b>Access</b> column displays a short summary of access control settings: </p><ul>
<li>
<b>...</b> button label means that there are no restrictions for this action  </li>
<li>
<b>Rules: N</b> button label means that there are N access control rules for this action  </li>
</ul>
<p>All actions are divided into two major categories, as indicated in the <b>Fixed</b> column of the table: </p><ul>
<li>
<b>Fixed</b> actions are either part of the AS EWO, or part of the CTRL libraries and panels included in this component. 'Fixed' here means that their names cannot be changed, and that the actions cannot be removed. All fixed actions are always shown in the table.  </li>
<li>
<b>User</b> actions can be added during the configuration of a particular project. For example, one can add new items to the <a class="el" href="page_ConfigAdmin.html#sec_AdminPopupMenu">right-click popup menu</a> and required that it is available only to selected users. In such case, a new (and unique) action name has to be defined and rules for access control need to be set for it.  </li>
</ul>
<dl class="section note"><dt>Note</dt><dd>Unlike 'fixed' actions, 'user' actions only appear in the table automatically if there are already some rules (restrictions) for them.</dd></dl>
<p>The functionality of the Add/Remove buttons (on the right of the table), as well as the Apply/Close buttons at bottom part of panel follow the typical conventions.</p>
<p>Clicking on the button in the <b>Access</b> column will open the following panel, allowing to edit access control restrictions for the clicked action:</p>
<div class="image">
<img src="accessControlRules.png" alt=""/>
<div class="caption">
Editing access control rules for an action</div></div>
 <p>The table contains the list of privileges in domains, required for executing the selected action. The <b>Domain</b> and <b>Privilege</b> columns use combo boxes for editing, allowing the user to select one of the domains defined in the project, and one of the privileges defined in the selected domain. If several domain/privilege pairs are specified, they will be joined by the OR operator, i.e. the action is allowed for all users who match any of the criteria.</p>
<p>Usually actions are initiated from elements of the UI, like buttons and menu items. The combo box below the table allows choosing how such widgets shall look for users who do not have the necessary privileges. Two possibilities exist:</p>
<ul>
<li>
<b>Disable control</b>: the widget for initiating the action is visible, but appears disabled (grayed-out)  </li>
<li>
<b>Hide control</b>: the widget is hidden, i.e. the user will not even see it  </li>
</ul>
<p>The functionality the remaining buttons in the panel is self-explanatory.</p>
<h1><a class="anchor" id="sec_AdminPopupMenu"></a>
Popup menu configuration</h1>
<p>The second item of the <a class="el" href="page_ConfigAdmin.html#anchor_AdminMenu">Admin Settings menu</a> opens the the panel used to edit the popup menu that appears when the user clicks on the Alarm Table with the right mouse button:</p>
<div class="image">
<img src="popupMenuEditor.png" alt=""/>
<div class="caption">
Popup menu editor</div></div>
 <dl class="section note"><dt>Note</dt><dd>The settings from this panel may be ignored depending on the <a class="el" href="page_RefJson.html#subsec_RefJsonBasicConfigMouseProc">basic configuration</a> in use.</dd></dl>
<p>The rows in the table contain the labels for the items in the popup menu. For the moment, only push button items are supported. The controls below the table are used to view/edit the processing method for the selected row.</p>
<ul>
<li>
<b>Action name</b> combo box is used to select one of the existing (fixed) actions, associated with this menu item, or to add a new action name for this item. Action names can be used to restrict access to items in the right-click menu as configured in the <a class="el" href="page_ConfigAdmin.html#sec_AccessControl">access control settings</a>. The name can also be used during processing of item selection as they are passed to the handling function.  </li>
<li>
<b>Processing of menu item selection</b> frame contains two texts, used to specify the CTRL function that will be called when the item is selected in the menu. The name of the CTRL library to which this function belongs is optional and may be left empty, as long as it is guaranteed (e.g. by using loadCtrlLibs in the config file) that the library is always loaded before the AS is started.  </li>
<li>
<b>Calculation of menu item appearance</b> frame contains two texts, used to specify the CTRL function that will be called when the popup menu is being built. The purpose of the function is to define which items should appear in the menu depending on the clicked alarm row and the state of the system (access control is usually not handled by this function). For example, the 'Trend' item from the menu above does not make sense for summary alarms, so the CTRL function can check what type of alarm was clicked, and disable the item if necessary.<br  />
 Same rules as in the case of selection processing apply to entering the CTRL library name.  </li>
</ul>
<p>Both CTRL functions must have certain signatures - see the EWO's <a class="el" href="page_RefEwo.html#sec_RefEwoEvents">Events</a>. Examples can be found in the CTRL library <b>AlarmScreenMenuJCOP.ctl</b>.</p>
<h1><a class="anchor" id="sec_AdminOracleAccess"></a>
ORACLE archive connection</h1>
<p>In order to query archived alarms from <a class="el" href="pageUsingAS.html#secSourceTypes">ORACLE archives</a>, the AS EWO needs to know how to connect to the corresponding DB. The following panel is used to configure the connection:</p>
<div class="image">
<img src="oracleAccess.png" alt=""/>
<div class="caption">
Editing settings for ORACLE archive access</div></div>
 <p>The <b>Test</b> button in lower left corner of panel can be used to try connection to ORACLE database using supplied connection parameters.<br  />
</p>
<p>In addition to the database credentials, the AS EWO needs three more settings: </p><ul>
<li>
<b>Maximum number of alarms from archive</b>: archives can contain huge numbers of alarms and trying to load all of them is not a feasible strategy. The purpose of this setting is to limit the number of alarms returned by a single query. The default is 50000.  </li>
<li>
<b>Number of alarms in one processing batch</b>: archives are queried using a dedicated processing thread, but some part of processing of queried data has to be performed by the main thread, due to the limitations of the WinCC OA API. The thread running the query puts the results in an internal queue for processing by the main thread. This setting allows to specify the number of alarms processed in a single batch (the unit of processing by the main thread). Higher values can lead to visible 'freezes' of the user interface (which also runs on 'main' thread). Too low values lead to increased overall processing time due to the overhead. The default is 500.  </li>
<li>
<b>Maximum number of pending batches</b>: as explained in the previous point, the thread running the query places the results in an internal queue and the main thread takes the data from it for final processing. The processing of data is slower than adding data, so the memory required for raw data in the queue may grow significantly during the query execution. This setting allows to limit the number of batches pending in the queue. The default is 20.  </li>
</ul>
<h1><a class="anchor" id="sec_HelpFileTypes"></a>
Help File Types</h1>
<p>The standard (JCOP-style) configuration assumes that the project can contain a number of device/value specific help files that can be shown to the user. The locations and names for such help files must follow certain rules (see <a class="el" href="page_RefHelpFiles.html">Help files</a>). In addition: </p><ul>
<li>
Only the files of preconfigured types can be opened using the implemented mechanism </li>
<li>
Different file types can be opened using different commands of the operating system </li>
</ul>
<p>The following panel, opened by clicking 'Help File types' in the <a class="el" href="page_ConfigAdmin.html#anchor_AdminMenu">Admin Settings menu</a>, is used to modify the set of supported file types and to specify the command to open the files of a given type:</p>
<div class="image">
<img src="helpFileTypes.png" alt=""/>
<div class="caption">
Editing setting for help file types</div></div>
 <p>The configuration is performed directly in the table cells. If no specific command is written for a given file type (i.e. if corresponding cell says '(default)'), then the JCOP-default command will be used. The default JCOP commands are displayed for reference in the text fields below the table. </p>
</div></div><!-- contents -->
</div><!-- PageDoc -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1
</small></address>
</body>
</html>
